display=new Object();
display.grb8=new Object();
display.grb125=new Object();
display.img=new Image();
display.init=function(){
	// Set the contexts.
	this.picorg=dom.getContext("picorg");
	this.picres=dom.getContext("picres");
	this.textres=dom.getElement("textres");
	this.save=dom.getElement("save");
	// Load the image.
//	this.img.src="./image.jpg?"+ new Date().getTime();
};
display.upload=function(obj){
	var reader = new FileReader();
	reader.onload = function(obj) {
		display.img.src = obj.target.result;
	};
	reader.readAsDataURL(obj.files[0]);
};
display.img.onload=function(){
	display.onload();
}
// display.onload will be called after sucessfull loading of font PNG image.
display.onload=function(){
	var i,r,g,b,d1,d2,d3,d4,x,y,data,i32,text;
	// Show the image
	this.picorg.drawImage(this.img,0,0);
	this.textres.value='';
	// Draw 8 lines for 8 colors and get 8 dot images.
	for (i=0;i<8;i++) {
		this.picres.beginPath();
		this.picres.strokeStyle  = 'rgb('+(i&2?'256':'0')+','+(i&4?'256':'0')+','+(i&1?'256':'0')+')';
		this.picres.moveTo(0,i);
		this.picres.lineTo(319,i);
		this.picres.closePath();
		this.picres.stroke();
		this.grb8[i]=this.picres.getImageData(0,i,1,1);
	}
	// Construct 125 color images (2x2 size)
	for (r=0;r<5;r++) {
		for (g=0;g<5;g++) {
			for (b=0;b<5;b++) {
				d1=d2=d3=d4=0;
				switch(g){
					case 4: d1+=4;
					case 3: d2+=4;
					case 2: d3+=4;
					case 1: d4+=4;
					case 0: break;
				}
				switch(r){
					case 4: d2+=2;
					case 3: d3+=2;
					case 2: d4+=2;
					case 1: d1+=2;
					case 0: break;
				}
				switch(b){
					case 4: d3+=1;
					case 3: d4+=1;
					case 2: d1+=1;
					case 1: d2+=1;
					case 0: break;
				}
				this.picres.putImageData(this.grb8[d1],0,0);
				this.picres.putImageData(this.grb8[d2],0,1);
				this.picres.putImageData(this.grb8[d3],1,0);
				this.picres.putImageData(this.grb8[d4],1,1);
				this.grb125[r*25+g*5+b]=this.picres.getImageData(0,0,2,2);
			}
		}
	}
	// Investigate original image and construct 125-colored image
	for(y=0;y<120;y++){
		for(x=0;x<160;x++){
			data=this.picorg.getImageData(x,y,1,1).data;
			r=parseInt(5*data[0]/256);
			g=parseInt(5*data[1]/256);
			b=parseInt(5*data[2]/256);
			this.picres.putImageData(this.grb125[r*25+g*5+b],x*2,y*2);
		}
	}
	// Investigate result image and construct text.
	text='';
	for(y=0;y<240;y++){
		for(x=0;x<320;x+=10){
			i32=new Object;
			for(i=0;i<10;i++){
				data=this.picres.getImageData(x+i,y,1,1).data;
				r=data[0]?1:0;
				g=data[1]?1:0;
				b=data[2]?1:0;
				i32[i]=g*4+r*2+b;
			}
			// Save as "8887 7766 6555 4443"+"3322 2111 0009 99xx".
			text+='0x';
			text+=('000'+(((i32[3]&4)>>2)|(i32[4]<<1)|(i32[5]<<4)|(i32[6]<<7)|(i32[7]<<10)|(i32[8]<<13)).toString(16)).substr(-4);
			text+=('000'+((i32[9]<<2)|(i32[0]<<5)|(i32[1]<<8)|(i32[2]<<11)|((i32[3]&3)<<14)).toString(16)).substr(-4);
			text+=',';
			if (((x/10)&7)==7) text+='\r\n';
		}
	}
	this.textres.value=text;
	save.href="data:application/octet-stream,"+escape(text);
	save.style.display="block";
};
